import random

######################################################################
#   Distributions

class Dist:
    def __init__(self, sampleSpace):
        self.sampleSpace = sampleSpace
    def draw(self):
        r = random.random()
        sum = 0.0
        for (val, prob) in self.sampleSpace:
            sum += prob
            if r < sum:
                return val
    def __repr__(self):
        return "Dist(" + repr(self.sampleSpace) + ")"
    def prob(self, val):
        for (v,p) in self.sampleSpace:
            if v == val:
                return p
        return 0
        
